import { FC } from 'react';
import { IVarBaseInputProps } from './VarBase';
export interface IVarFileProps extends IVarBaseInputProps<File> {
    /**
     * Accepted file types.
     */
    accept?: string;
    /**
     * Show metadata.
     * Default: true.
     */
    displayMetadata?: boolean;
}
/**
 * File input component. Accepts and provides a File instance.
 */
export declare const VarFile: FC<IVarFileProps>;
