import e, { createContext as W, useContext as j, useMemo as k, useCallback as p, useRef as U, useEffect as z, useState as Y } from "react";
import H from "lodash.clonedeep";
import q from "lodash.set";
import G from "lodash.result";
import { usePointerDrag as L } from "react-use-pointer-drag";
import { SketchPicker as K } from "react-color";
import Q from "filesize";
const $ = W(void 0);
function w(a, o, s) {
  const c = j($), t = k(() => (c == null ? void 0 : c.getValue(a)) ?? o, [
    c,
    a,
    o
  ]), l = p(
    (r) => {
      a && c && c.setValue(a, r), s == null || s(r);
    },
    [a, c, s]
  );
  return [t, l];
}
const le = ({
  values: a,
  updateValues: o,
  className: s,
  children: c
}) => {
  const t = p(
    (n) => n ? G(a, n) : void 0,
    [a]
  ), l = p(
    (n, i) => {
      o(q(H(a), n, i));
    },
    [a, o]
  ), r = k(
    () => ({ values: a, getValue: t, setValue: l }),
    [a, t, l]
  );
  return /* @__PURE__ */ e.createElement($.Provider, { value: r }, /* @__PURE__ */ e.createElement("div", { className: "react-var-ui " + (s || "") }, c));
}, N = ({
  label: a,
  children: o,
  className: s,
  disabled: c
}) => /* @__PURE__ */ e.createElement(
  "div",
  {
    className: "react-var-ui-label " + (a ? "react-var-ui-label-has-label " : "react-var-ui-label-no-label ") + (c ? "react-var-ui-disabled " : "") + (s || "")
  },
  !!a && /* @__PURE__ */ e.createElement("span", null, a),
  o
), R = Math.PI * 2;
function D(a) {
  return (R + a % R) % R;
}
const ce = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  disabled: t,
  defaultValue: l = 0,
  className: r
}) => {
  const n = U(null), [i, d] = w(o, s, c), m = k(
    () => Math.round(D(i) * (180 / Math.PI)),
    [i]
  ), { dragProps: g } = L({
    onMove: ({ x: u, y: v }) => {
      if (!n.current)
        return;
      const E = n.current.getBoundingClientRect(), V = E.left + E.width / 2, h = E.top + E.height / 2;
      d(D(Math.atan2(v - h, u - V) + Math.PI / 2));
    }
  });
  return z(() => {
    var u;
    (u = n.current) == null || u.addEventListener("wheel", (v) => v.preventDefault());
  }, []), /* @__PURE__ */ e.createElement(N, { label: a, disabled: t, className: r }, /* @__PURE__ */ e.createElement("span", { className: "react-var-ui-angle-value" }, m, "°"), /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-angle" }, /* @__PURE__ */ e.createElement(
    "div",
    {
      className: "react-var-ui-angle-control",
      ref: n,
      style: { transform: `rotate(${m}deg)` },
      onDoubleClick: () => typeof l < "u" && d(l),
      onWheel: (u) => {
        d(D(i + 0.5 * (u.deltaY < 0 ? -1 : 1)));
      },
      title: "Angle",
      ...g()
    }
  )));
}, oe = ({
  label: a,
  onClick: o,
  buttonLabel: s,
  disabled: c,
  className: t
}) => /* @__PURE__ */ e.createElement(N, { label: a, disabled: c, className: t }, /* @__PURE__ */ e.createElement("span", { className: "react-var-ui-button" }, /* @__PURE__ */ e.createElement("button", { onClick: () => o == null ? void 0 : o(), disabled: c }, s))), se = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  alpha: t,
  disabled: l,
  className: r
}) => {
  const [n, i] = w(o, s, c), [d, m] = Y(!1), g = p(() => m((v) => !v), [m]), u = p(() => m(!1), [m]);
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: l, className: r }, /* @__PURE__ */ e.createElement("span", null, /* @__PURE__ */ e.createElement("span", { className: "react-var-ui-color-value" }, n), /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-color" }, /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-color-swatch", onClick: g }, /* @__PURE__ */ e.createElement(
    "div",
    {
      className: "react-var-ui-color-color",
      title: "Color preview",
      style: { background: n }
    }
  )), d ? /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-color-popover" }, /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-color-cover", onClick: u }), /* @__PURE__ */ e.createElement(
    K,
    {
      color: n,
      onChange: (v) => {
        const f = v.hex === "transparent" ? "#000000" : v.hex;
        if (t) {
          let E = Math.round(
            (v.rgb.a ?? 1) * 255
          ).toString(16);
          E.length === 1 && (E = "0" + E), i(f + E);
        } else
          i(f);
      },
      disableAlpha: !t
    }
  )) : null)));
}, ie = ({
  label: a,
  path: o,
  value: s,
  disabled: c,
  className: t
}) => {
  const [l] = w(o, s);
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: c, className: t }, /* @__PURE__ */ e.createElement("span", null, l));
}, B = () => /* @__PURE__ */ e.createElement(
  "svg",
  {
    xmlns: "http://www.w3.org/2000/svg",
    width: "16",
    height: "16",
    fill: "currentColor",
    viewBox: "0 0 16 16"
  },
  /* @__PURE__ */ e.createElement("path", { d: "M.5 9.9a.5.5 0 0 1 .5.5v2.5a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-2.5a.5.5 0 0 1 1 0v2.5a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2v-2.5a.5.5 0 0 1 .5-.5z" }),
  /* @__PURE__ */ e.createElement("path", { d: "M7.646 1.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 2.707V11.5a.5.5 0 0 1-1 0V2.707L5.354 4.854a.5.5 0 1 1-.708-.708l3-3z" })
), ue = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  disabled: t,
  className: l,
  accept: r,
  displayMetadata: n = !0
}) => {
  const [i, d] = w(o, s, c), m = p(
    (g) => {
      var v;
      if (!((v = g.target.files) != null && v.length))
        return;
      const u = g.target.files[0];
      d(u);
    },
    [d]
  );
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: t, className: l }, /* @__PURE__ */ e.createElement("span", { className: "react-var-ui-file-value" }, i == null ? void 0 : i.name), /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-file" }, n && !!i && /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-file-metadata" }, /* @__PURE__ */ e.createElement("div", null, "File size: ", Q(i.size)), /* @__PURE__ */ e.createElement("div", null, "File type: ", i.type || "unknown")), /* @__PURE__ */ e.createElement(B, null), /* @__PURE__ */ e.createElement(
    "input",
    {
      type: "file",
      accept: r,
      onChange: m,
      title: "File upload"
    }
  )));
}, de = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  disabled: t,
  className: l
}) => {
  const [r, n] = w(o, s, c), i = p(
    (d) => {
      var u;
      if (!((u = d.target.files) != null && u.length))
        return;
      const m = d.target.files[0], g = URL.createObjectURL(m);
      n(g);
    },
    [n]
  );
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: t, className: l }, /* @__PURE__ */ e.createElement("span", { className: "react-var-ui-image-value" }), /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-image" }, /* @__PURE__ */ e.createElement(
    "div",
    {
      className: "react-var-ui-image-background",
      style: {
        backgroundImage: r ? `url('${r}')` : void 0
      },
      title: "Image preview"
    }
  ), /* @__PURE__ */ e.createElement(B, null), /* @__PURE__ */ e.createElement(
    "input",
    {
      type: "file",
      accept: "image/*",
      onChange: i,
      title: "Image upload"
    }
  )));
}, me = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  disabled: t,
  className: l,
  acceptImage: r,
  acceptAudio: n,
  acceptVideo: i
}) => {
  const [d, m] = w(o, s, c), [g, u] = Y(), v = k(() => {
    let h = "";
    return r && (h += "image/*,"), n && (h += "audio/*,"), i && (h += "video/*,"), h.endsWith(",") && (h = h.slice(0, -1)), h || (h = "image/*,audio/*,video/*"), h;
  }, [r, n, i]), f = p(
    (h) => {
      var M;
      if (!((M = h.target.files) != null && M.length))
        return;
      const y = h.target.files[0], b = URL.createObjectURL(y);
      m(b);
    },
    [m, u]
  ), E = p(
    async (h) => {
      var b, M, I;
      if (!h) {
        u(void 0);
        return;
      }
      const y = await fetch(h);
      u((I = (M = (b = y == null ? void 0 : y.headers) == null ? void 0 : b.get("Content-Type")) == null ? void 0 : M.split("/")) == null ? void 0 : I[0]);
    },
    [u]
  );
  z(() => {
    E(d);
  }, [d]);
  let V = /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-media-metadata" }, d ? "Unsupported file type." : "");
  switch (g) {
    case "image":
      V = /* @__PURE__ */ e.createElement(
        "div",
        {
          className: "react-var-ui-media-background",
          style: {
            backgroundImage: `url('${d}')`
          },
          title: "Media preview"
        }
      );
      break;
    case "video":
      V = /* @__PURE__ */ e.createElement(
        "video",
        {
          className: "react-var-ui-media-background",
          muted: !0,
          loop: !0,
          autoPlay: !0,
          src: d,
          title: "Media preview"
        }
      );
      break;
    case "audio":
      V = /* @__PURE__ */ e.createElement(
        "audio",
        {
          className: "react-var-ui-media-audio",
          loop: !0,
          controls: !0,
          src: d,
          title: "Media preview"
        }
      );
      break;
  }
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: t, className: l }, /* @__PURE__ */ e.createElement("span", { className: "react-var-ui-media-value" }), /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-media" }, V, /* @__PURE__ */ e.createElement(B, null), /* @__PURE__ */ e.createElement(
    "input",
    {
      type: "file",
      accept: v,
      onChange: f,
      title: "Media upload"
    }
  )));
};
function S(a, o, s, c, t) {
  var r;
  isFinite(a) || (a = o ?? 0);
  let l = 2;
  return typeof c == "number" && (l = ((r = c.toString().split(".")[1]) == null ? void 0 : r.length) || 0, l > 20 && (l = 20), a = Math.round(a / c) * c), typeof o == "number" && (a = Math.max(o, a)), typeof s == "number" && (a = Math.min(s, a)), t ? Math.round(a) : parseFloat(a.toFixed(l));
}
const T = () => /* @__PURE__ */ e.createElement(
  "svg",
  {
    xmlns: "http://www.w3.org/2000/svg",
    width: "16",
    height: "16",
    fill: "currentColor",
    viewBox: "0 0 16 16"
  },
  /* @__PURE__ */ e.createElement(
    "path",
    {
      fillRule: "evenodd",
      d: "M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z"
    }
  )
), X = () => /* @__PURE__ */ e.createElement(
  "svg",
  {
    xmlns: "http://www.w3.org/2000/svg",
    width: "16",
    height: "16",
    fill: "currentColor",
    viewBox: "0 0 16 16"
  },
  /* @__PURE__ */ e.createElement(
    "path",
    {
      fillRule: "evenodd",
      d: "M7.646 4.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1-.708.708L8 5.707l-5.646 5.647a.5.5 0 0 1-.708-.708l6-6z"
    }
  )
), ve = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  min: t,
  max: l,
  step: r = 1,
  integer: n,
  showButtons: i,
  disabled: d,
  className: m
}) => {
  const [g, u] = w(o, s, c), v = k(
    () => S(g, t, l, r, !!n),
    [g, t, l, r, n]
  ), f = p(
    () => u(
      S(g + (r ?? 1), t, l, r, !!n)
    ),
    [g, u, n, t, l, r]
  ), E = p(
    () => u(
      S(g - (r ?? 1), t, l, r, !!n)
    ),
    [g, u, n, t, l, r]
  );
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: d, className: m }, /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-number" }, /* @__PURE__ */ e.createElement(
    "input",
    {
      className: "react-var-ui-number-input",
      type: "number",
      min: t,
      max: l,
      step: r,
      value: v.toString(),
      onChange: (V) => u(
        S(parseFloat(V.target.value), t, l, r, !!n)
      )
    }
  ), i && /* @__PURE__ */ e.createElement(e.Fragment, null, /* @__PURE__ */ e.createElement("button", { title: "Increase", onClick: f }, /* @__PURE__ */ e.createElement(X, null)), /* @__PURE__ */ e.createElement("button", { title: "Decrease", onClick: E }, /* @__PURE__ */ e.createElement(T, null)))));
}, ge = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  options: t,
  disabled: l,
  className: r
}) => {
  const [n, i] = w(o, s, c), d = k(() => JSON.stringify(n), [
    n
  ]);
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: l, className: r }, /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-select" }, /* @__PURE__ */ e.createElement(
    "select",
    {
      onChange: (m) => i(JSON.parse(m.target.value)),
      value: d,
      title: "Select options"
    },
    t.map((m) => {
      const g = JSON.stringify(m.value ?? m.key);
      return /* @__PURE__ */ e.createElement("option", { key: m.key, value: g }, m.label);
    })
  )));
}, Ee = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  min: t,
  max: l,
  step: r,
  integer: n,
  defaultValue: i,
  showInput: d,
  showButtons: m,
  disabled: g,
  className: u
}) => {
  const v = U(null), [f, E] = w(o, s, c), V = k(
    () => S(f, t, l, r, !!n),
    [f, t, l, r, n]
  ), h = k(() => (V - t) / (l - t) * 100, [
    V,
    t,
    l
  ]), y = p(
    (C) => {
      if (!v.current)
        return;
      const P = v.current.getBoundingClientRect(), A = (C - P.left) / P.width, J = S(
        t + (l - t) * A,
        t,
        l,
        r,
        !!n
      );
      E(J);
    },
    [E, n, t, l, r]
  ), b = p(
    () => E(
      S(f + r, t, l, r, !!n)
    ),
    [f, E, n, t, l, r]
  ), M = p(
    () => E(
      S(f - r, t, l, r, !!n)
    ),
    [f, E, n, t, l, r]
  ), { dragProps: I } = L({
    onMove: ({ x: C }) => y(C)
  });
  return z(() => {
    var C;
    (C = v.current) == null || C.addEventListener("wheel", (F) => F.preventDefault());
  }, []), /* @__PURE__ */ e.createElement(N, { label: a, disabled: g, className: u }, /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-slider" }, /* @__PURE__ */ e.createElement(
    "div",
    {
      className: "react-var-ui-slider-track",
      ref: v,
      onClick: (C) => y(C.clientX),
      onDoubleClick: () => typeof i < "u" && E(i),
      onWheel: (C) => {
        C.deltaY < 0 ? b() : M();
      },
      title: "Slider",
      ...I()
    },
    /* @__PURE__ */ e.createElement(
      "div",
      {
        className: "react-var-ui-slider-content",
        style: { width: h + "%" }
      }
    )
  ), d ? /* @__PURE__ */ e.createElement(
    "input",
    {
      className: "react-var-ui-slider-input",
      type: "number",
      min: t,
      max: l,
      step: r,
      value: V,
      onChange: (C) => E(
        S(
          parseFloat(C.target.value),
          t,
          l,
          r,
          !!n
        )
      )
    }
  ) : /* @__PURE__ */ e.createElement("span", null, V.toString()), m && /* @__PURE__ */ e.createElement(e.Fragment, null, /* @__PURE__ */ e.createElement("button", { title: "Increase", onClick: b }, /* @__PURE__ */ e.createElement(X, null)), /* @__PURE__ */ e.createElement("button", { title: "Decrease", onClick: M }, /* @__PURE__ */ e.createElement(T, null)))));
}, fe = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  maxLength: t,
  multiline: l,
  autoexpand: r,
  disabled: n,
  className: i
}) => {
  const [d, m] = w(o, s, c), g = (v) => {
    const f = v.currentTarget;
    f.style.height = "0", f.style.height = `${f.scrollHeight}px`;
  }, u = k(
    () => r ? { overflow: "hidden", resize: "none" } : void 0,
    [r]
  );
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: n, className: i }, l ? /* @__PURE__ */ e.createElement(
    "textarea",
    {
      className: "react-var-ui-string-multiline",
      value: d,
      onChange: (v) => m(v.target.value),
      onInput: r ? g : void 0,
      style: u
    }
  ) : /* @__PURE__ */ e.createElement("span", { className: "react-var-ui-string" }, /* @__PURE__ */ e.createElement(
    "input",
    {
      type: "text",
      maxLength: t,
      value: d,
      onChange: (v) => m(v.target.value)
    }
  )));
}, he = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  disabled: t,
  className: l
}) => {
  const [r, n] = w(o, s, c);
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: t, className: l }, /* @__PURE__ */ e.createElement("span", null, /* @__PURE__ */ e.createElement("label", { className: "react-var-ui-toggle", title: "Toggle" }, /* @__PURE__ */ e.createElement(
    "input",
    {
      type: "checkbox",
      checked: r,
      onChange: (i) => n(i.target.checked)
    }
  ), /* @__PURE__ */ e.createElement("span", { className: "react-var-ui-toggle-helper" }))));
};
function O(a, o, s, c) {
  var l;
  const t = [0, 0];
  if (!a || !Array.isArray(a) || a.length < 2)
    return t;
  for (let r = 0; r < c.length; r++) {
    const n = ((l = c[r].toString().split(".")[1]) == null ? void 0 : l.length) || 0;
    t[r] = Math.round(a[r] / c[r]) * c[r], t[r] = Math.max(o[r], t[r]), t[r] = Math.min(s[r], t[r]), t[r] = parseFloat(t[r].toFixed(n));
  }
  return t;
}
function Z(a, o, s) {
  if (!a)
    return [50, 50];
  const c = [0, 0];
  for (let t = 0; t < a.length; t++)
    c[t] = (a[t] - o[t]) / (s[t] - o[t]) * 100;
  return c;
}
const pe = ({
  label: a,
  path: o,
  value: s,
  onChange: c,
  disabled: t,
  className: l,
  defaultValue: r = [0, 0],
  min: n = [-1, -1],
  max: i = [1, 1],
  step: d = [0.01, 0.01]
}) => {
  const m = U(null), [g, u] = w(o, s, c), v = k(() => O(g, n, i, d), [
    g,
    n,
    i,
    d
  ]), f = k(() => Z(v, n, i), [
    v,
    n,
    i
  ]), E = p(
    (y, b) => {
      if (!m.current)
        return;
      const I = m.current.getBoundingClientRect(), C = (y - I.left) / I.width, F = (b - I.top) / I.height, P = O(
        [
          n[0] + (i[0] - n[0]) * C,
          n[1] + (i[1] - n[1]) * F
        ],
        n,
        i,
        d
      );
      u(P);
    },
    [u, n, i, d]
  ), { dragProps: V } = L({
    onMove: ({ x: y, y: b }) => E(y, b)
  }), h = p(() => {
    typeof r < "u" && u(r);
  }, [r, u]);
  return /* @__PURE__ */ e.createElement(N, { label: a, disabled: t, className: l }, /* @__PURE__ */ e.createElement("span", { className: "react-var-ui-xy-value" }, v[0], ", ", v[1]), /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-xy" }, /* @__PURE__ */ e.createElement(
    "div",
    {
      className: "react-var-ui-xy-space",
      ref: m,
      onClick: (y) => E(y.clientX, y.clientY),
      onDoubleClick: h,
      ...V()
    },
    /* @__PURE__ */ e.createElement(
      "div",
      {
        className: "react-var-ui-xy-control",
        style: { top: f[1] + "%", left: f[0] + "%" }
      }
    )
  )));
}, Ve = ({
  label: a,
  className: o,
  children: s
}) => /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-category " + (o || "") }, /* @__PURE__ */ e.createElement("div", { className: "react-var-ui-category-title" }, a), !!s && /* @__PURE__ */ e.createElement("div", null, s));
export {
  ce as VarAngle,
  N as VarBase,
  oe as VarButton,
  Ve as VarCategory,
  se as VarColor,
  ie as VarDisplay,
  ue as VarFile,
  de as VarImage,
  me as VarMedia,
  ve as VarNumber,
  ge as VarSelect,
  Ee as VarSlider,
  fe as VarString,
  he as VarToggle,
  le as VarUI,
  pe as VarXY,
  w as useVarUIValue
};
